/*
 *  JVending
 *  Copyright (C) 2004  Shane Isbell
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package javax.provisioning;

import java.io.InputStream;
import java.io.IOException;

import java.util.List;
import java.util.Collection;

/**
 * A BundleRepository represents an entry point to the servers repository of client bundles. 
 * Applications obtain a BundleRepository instance by calling the ProvisioningContext.getBundleRepository method.
 */

public interface BundleRepository {

    public long addParFile(InputStream inputStream) throws IOException;

    public void emptyRepository() throws IOException;

    public BundleDescriptor getBundleByID(String bundleID);

    public Collection getBundlesFor(Capabilities deviceCapabilities, List matchPolicies) 
        throws IOException;

    public Collection getBundlesFor(Capabilities deviceCapabilities, List matchPolicies,
        boolean allVersions, boolean allVariants) throws IOException;

    public float matchAttribute(String attributeName, List requirementValues, 
        List capabilityValues);

    public void removeParFile(long parFileID) throws IOException;

}